Index: pobyso.py
===================================================================
--- pobyso.py	(revision 218)
+++ pobyso.py	(revision 219)
@@ -1128,17 +1128,19 @@
                                                            itpSo,
                                                            ftpSo,
                                                            maxPrecSo,
-                                                           maxErrSo):
-    print "Input arguments:"
-    #pobyso_autoprint(polySo)
-    #pobyso_autoprint(funcSo)
-    #pobyso_autoprint(icSo)
-    #pobyso_autoprint(intervalSo)
-    #pobyso_autoprint(itpSo)
-    #pobyso_autoprint(ftpSo)
-    #pobyso_autoprint(maxPrecSo)
-    #pobyso_autoprint(maxErrSo)
-    #print "________________"
+                                                           maxErrSo,
+                                                           debug=False):
+    if debug:
+        print "Input arguments:"
+        pobyso_autoprint(polySo)
+        pobyso_autoprint(funcSo)
+        pobyso_autoprint(icSo)
+        pobyso_autoprint(intervalSo)
+        pobyso_autoprint(itpSo)
+        pobyso_autoprint(ftpSo)
+        pobyso_autoprint(maxPrecSo)
+        pobyso_autoprint(maxErrSo)
+        print "________________"
     
     ## Higher order function see: 
     #  http://effbot.org/pyfaq/how-do-you-make-a-higher-order-function-in-python.htm
@@ -1155,20 +1157,21 @@
     
     #
     degreeSa        = pobyso_polynomial_degree_so_sa(polySo)
-    print "degreeSa:", degreeSa
     ratio           = precision_decay_ratio_function(degreeSa)
-    print "ratio:", ratio
     itpSa           = pobyso_constant_from_int_so_sa(itpSo)
-    print "itpsSa:", itpSa
     ftpSa           = pobyso_constant_from_int_so_sa(ftpSo)
-    print "ftpSa:", ftpSa
     maxPrecSa       = pobyso_constant_from_int_so_sa(maxPrecSo)
-    print "maxPrecSa:", maxPrecSa
     maxErrSa        = pobyso_get_constant_as_rn_so_sa(maxErrSo)
-    print "maxErrSa:", maxErrSa
+    if debug:
+        print "degreeSa:", degreeSa
+        print "ratio:", ratio
+        print "itpsSa:", itpSa
+        print "ftpSa:", ftpSa
+        print "maxPrecSa:", maxPrecSa
+        print "maxErrSa:", maxErrSa
     lastResPolySo   = None
     lastInfNormSo   = None
-    print "About to enter the while loop..."
+    #print "About to enter the while loop..."
     while True: 
         resPolySo   = pobyso_constant_0_sa_so()
         pDeltaSa    = ftpSa - itpSa
@@ -1179,8 +1182,9 @@
             #print ratio(indexSa)
             ctpSa = floor(ftpSa - (pDeltaSa * ratio(indexSa)))
             ctpSo = pobyso_constant_from_int_sa_so(ctpSa)
-            print "Index:", indexSa, " - Target precision:", 
-            pobyso_autoprint(ctpSo)
+            if debug:
+                print "Index:", indexSa, " - Target precision:", 
+                pobyso_autoprint(ctpSo)
             cmonSo  = \
                 sollya_lib_build_function_mul(sollya_lib_coeff(polySo, indexSo),
                                       sollya_lib_build_function_pow( \
@@ -1201,13 +1205,17 @@
                                                   resPolyCvSo)
         infNormSo = sollya_lib_dirtyinfnorm(errFuncSo, intervalSo)
         cerrSa    = pobyso_get_constant_as_rn_so_sa(infNormSo)
-        print "Infnorm (Sollya):", pobyso_autoprint(infNormSo)
+        if debug:
+            print "Infnorm (Sollya):", 
+            pobyso_autoprint(infNormSo)
         sollya_lib_clear_obj(errFuncSo)
         #print "Infnorm  (Sage):", cerrSa
         if (cerrSa > maxErrSa):
-            print "Error is too large."
+            if debug:
+                print "Error is too large."
             if lastResPolySo is None:
-                print "Enlarging prec."
+                if debug:
+                    print "Enlarging prec."
                 ntpSa = floor(ftpSa + ftpSa/50)
                 ## Can't enlarge (numerical)
                 if ntpSa == ftpSa:
@@ -1221,15 +1229,18 @@
                 continue
             ## One enlargement took place.
             else:
-                print "Exit with the last before last polynomial."
+                if debug:
+                    print "Exit with the last before last polynomial."
                 sollya_lib_clear_obj(resPolySo)
                 sollya_lib_clear_obj(infNormSo)
                 return (lastResPolySo, lastInfNormSo)
         # cerrSa <= maxErrSa: scrap more bits, possibly.
         else:
-            print "Error is too small"
-            if cerrSa <= (maxErrSa/2): 
-                print "Shrinking prec."
+            if debug:
+                print "Error is too small"
+            if cerrSa <= (maxErrSa/2):
+                if debug: 
+                    print "Shrinking prec."
                 ntpSa = floor(ftpSa - ftpSa/50)
                 ## Can't shrink (numerical)
                 if ntpSa == ftpSa: